# This Python file uses the following encoding: utf-8
"""autogenerated by genpy from interactive_world_msgs/Configuration.msg. Do not edit."""
import sys
python3 = True if sys.hexversion > 0x03000000 else False
import genpy
import struct

import geometry_msgs.msg
import interactive_world_msgs.msg

class Configuration(genpy.Message):
  _md5sum = "f23b42b8efceda6c77fda2dc43c4ba2b"
  _type = "interactive_world_msgs/Configuration"
  _has_header = False #flag to mark the presence of a Header object
  _full_text = """string task                             # task description
interactive_world_msgs/Item[] items     # items in the world for the task
interactive_world_msgs/Room[] rooms     # rooms in the world

================================================================================
MSG: interactive_world_msgs/Item
string name       # name of the object
float64 width     # width of the object in meters (along the x-axis)
float64 height    # height of the object in meters (along the y-axis)

================================================================================
MSG: interactive_world_msgs/Room
string name                                  # name of the room
float64 width                                # width of the room in meters (along the x-axis)
float64 height                               # height of the room in meters (along the y-axis)
geometry_msgs/Pose pose                      # the position of the room relative to the world
interactive_world_msgs/Surface[] surfaces    # surfaces in the room

================================================================================
MSG: geometry_msgs/Pose
# A representation of pose in free space, composed of postion and orientation. 
Point position
Quaternion orientation

================================================================================
MSG: geometry_msgs/Point
# This contains the position of a point in free space
float64 x
float64 y
float64 z

================================================================================
MSG: geometry_msgs/Quaternion
# This represents an orientation in free space in quaternion form.

float64 x
float64 y
float64 z
float64 w

================================================================================
MSG: interactive_world_msgs/Surface
string name                                      # name of the surface
float64 width                                    # width of the surface in meters (along the x-axis)
float64 height                                   # height of the surface in meters (along the y-axis)
geometry_msgs/Pose pose                          # the position of the surface relative to its parent room
interactive_world_msgs/PointOfInterest[] pois    # POIs for the surface

================================================================================
MSG: interactive_world_msgs/PointOfInterest
string name                # name of the POI
float64 width              # width of the POI in meters (along the x-axis)
float64 height             # height of the POI in meters (along the y-axis)
geometry_msgs/Pose pose    # the position of the POI relative to its parent furniture
"""
  __slots__ = ['task','items','rooms']
  _slot_types = ['string','interactive_world_msgs/Item[]','interactive_world_msgs/Room[]']

  def __init__(self, *args, **kwds):
    """
    Constructor. Any message fields that are implicitly/explicitly
    set to None will be assigned a default value. The recommend
    use is keyword arguments as this is more robust to future message
    changes.  You cannot mix in-order arguments and keyword arguments.

    The available fields are:
       task,items,rooms

    :param args: complete set of field values, in .msg order
    :param kwds: use keyword arguments corresponding to message field names
    to set specific fields.
    """
    if args or kwds:
      super(Configuration, self).__init__(*args, **kwds)
      #message fields cannot be None, assign default values for those that are
      if self.task is None:
        self.task = ''
      if self.items is None:
        self.items = []
      if self.rooms is None:
        self.rooms = []
    else:
      self.task = ''
      self.items = []
      self.rooms = []

  def _get_types(self):
    """
    internal API method
    """
    return self._slot_types

  def serialize(self, buff):
    """
    serialize message into buffer
    :param buff: buffer, ``StringIO``
    """
    try:
      _x = self.task
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      if python3:
        buff.write(struct.pack('<I%sB'%length, length, *_x))
      else:
        buff.write(struct.pack('<I%ss'%length, length, _x))
      length = len(self.items)
      buff.write(_struct_I.pack(length))
      for val1 in self.items:
        _x = val1.name
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        if python3:
          buff.write(struct.pack('<I%sB'%length, length, *_x))
        else:
          buff.write(struct.pack('<I%ss'%length, length, _x))
        _x = val1
        buff.write(_struct_2d.pack(_x.width, _x.height))
      length = len(self.rooms)
      buff.write(_struct_I.pack(length))
      for val1 in self.rooms:
        _x = val1.name
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        if python3:
          buff.write(struct.pack('<I%sB'%length, length, *_x))
        else:
          buff.write(struct.pack('<I%ss'%length, length, _x))
        _x = val1
        buff.write(_struct_2d.pack(_x.width, _x.height))
        _v1 = val1.pose
        _v2 = _v1.position
        _x = _v2
        buff.write(_struct_3d.pack(_x.x, _x.y, _x.z))
        _v3 = _v1.orientation
        _x = _v3
        buff.write(_struct_4d.pack(_x.x, _x.y, _x.z, _x.w))
        length = len(val1.surfaces)
        buff.write(_struct_I.pack(length))
        for val2 in val1.surfaces:
          _x = val2.name
          length = len(_x)
          if python3 or type(_x) == unicode:
            _x = _x.encode('utf-8')
            length = len(_x)
          if python3:
            buff.write(struct.pack('<I%sB'%length, length, *_x))
          else:
            buff.write(struct.pack('<I%ss'%length, length, _x))
          _x = val2
          buff.write(_struct_2d.pack(_x.width, _x.height))
          _v4 = val2.pose
          _v5 = _v4.position
          _x = _v5
          buff.write(_struct_3d.pack(_x.x, _x.y, _x.z))
          _v6 = _v4.orientation
          _x = _v6
          buff.write(_struct_4d.pack(_x.x, _x.y, _x.z, _x.w))
          length = len(val2.pois)
          buff.write(_struct_I.pack(length))
          for val3 in val2.pois:
            _x = val3.name
            length = len(_x)
            if python3 or type(_x) == unicode:
              _x = _x.encode('utf-8')
              length = len(_x)
            if python3:
              buff.write(struct.pack('<I%sB'%length, length, *_x))
            else:
              buff.write(struct.pack('<I%ss'%length, length, _x))
            _x = val3
            buff.write(_struct_2d.pack(_x.width, _x.height))
            _v7 = val3.pose
            _v8 = _v7.position
            _x = _v8
            buff.write(_struct_3d.pack(_x.x, _x.y, _x.z))
            _v9 = _v7.orientation
            _x = _v9
            buff.write(_struct_4d.pack(_x.x, _x.y, _x.z, _x.w))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize(self, str):
    """
    unpack serialized message in str into this message instance
    :param str: byte array of serialized message, ``str``
    """
    try:
      if self.items is None:
        self.items = None
      if self.rooms is None:
        self.rooms = None
      end = 0
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.task = str[start:end].decode('utf-8')
      else:
        self.task = str[start:end]
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.items = []
      for i in range(0, length):
        val1 = interactive_world_msgs.msg.Item()
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          val1.name = str[start:end].decode('utf-8')
        else:
          val1.name = str[start:end]
        _x = val1
        start = end
        end += 16
        (_x.width, _x.height,) = _struct_2d.unpack(str[start:end])
        self.items.append(val1)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.rooms = []
      for i in range(0, length):
        val1 = interactive_world_msgs.msg.Room()
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          val1.name = str[start:end].decode('utf-8')
        else:
          val1.name = str[start:end]
        _x = val1
        start = end
        end += 16
        (_x.width, _x.height,) = _struct_2d.unpack(str[start:end])
        _v10 = val1.pose
        _v11 = _v10.position
        _x = _v11
        start = end
        end += 24
        (_x.x, _x.y, _x.z,) = _struct_3d.unpack(str[start:end])
        _v12 = _v10.orientation
        _x = _v12
        start = end
        end += 32
        (_x.x, _x.y, _x.z, _x.w,) = _struct_4d.unpack(str[start:end])
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        val1.surfaces = []
        for i in range(0, length):
          val2 = interactive_world_msgs.msg.Surface()
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          start = end
          end += length
          if python3:
            val2.name = str[start:end].decode('utf-8')
          else:
            val2.name = str[start:end]
          _x = val2
          start = end
          end += 16
          (_x.width, _x.height,) = _struct_2d.unpack(str[start:end])
          _v13 = val2.pose
          _v14 = _v13.position
          _x = _v14
          start = end
          end += 24
          (_x.x, _x.y, _x.z,) = _struct_3d.unpack(str[start:end])
          _v15 = _v13.orientation
          _x = _v15
          start = end
          end += 32
          (_x.x, _x.y, _x.z, _x.w,) = _struct_4d.unpack(str[start:end])
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          val2.pois = []
          for i in range(0, length):
            val3 = interactive_world_msgs.msg.PointOfInterest()
            start = end
            end += 4
            (length,) = _struct_I.unpack(str[start:end])
            start = end
            end += length
            if python3:
              val3.name = str[start:end].decode('utf-8')
            else:
              val3.name = str[start:end]
            _x = val3
            start = end
            end += 16
            (_x.width, _x.height,) = _struct_2d.unpack(str[start:end])
            _v16 = val3.pose
            _v17 = _v16.position
            _x = _v17
            start = end
            end += 24
            (_x.x, _x.y, _x.z,) = _struct_3d.unpack(str[start:end])
            _v18 = _v16.orientation
            _x = _v18
            start = end
            end += 32
            (_x.x, _x.y, _x.z, _x.w,) = _struct_4d.unpack(str[start:end])
            val2.pois.append(val3)
          val1.surfaces.append(val2)
        self.rooms.append(val1)
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e) #most likely buffer underfill


  def serialize_numpy(self, buff, numpy):
    """
    serialize message with numpy array types into buffer
    :param buff: buffer, ``StringIO``
    :param numpy: numpy python module
    """
    try:
      _x = self.task
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      if python3:
        buff.write(struct.pack('<I%sB'%length, length, *_x))
      else:
        buff.write(struct.pack('<I%ss'%length, length, _x))
      length = len(self.items)
      buff.write(_struct_I.pack(length))
      for val1 in self.items:
        _x = val1.name
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        if python3:
          buff.write(struct.pack('<I%sB'%length, length, *_x))
        else:
          buff.write(struct.pack('<I%ss'%length, length, _x))
        _x = val1
        buff.write(_struct_2d.pack(_x.width, _x.height))
      length = len(self.rooms)
      buff.write(_struct_I.pack(length))
      for val1 in self.rooms:
        _x = val1.name
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        if python3:
          buff.write(struct.pack('<I%sB'%length, length, *_x))
        else:
          buff.write(struct.pack('<I%ss'%length, length, _x))
        _x = val1
        buff.write(_struct_2d.pack(_x.width, _x.height))
        _v19 = val1.pose
        _v20 = _v19.position
        _x = _v20
        buff.write(_struct_3d.pack(_x.x, _x.y, _x.z))
        _v21 = _v19.orientation
        _x = _v21
        buff.write(_struct_4d.pack(_x.x, _x.y, _x.z, _x.w))
        length = len(val1.surfaces)
        buff.write(_struct_I.pack(length))
        for val2 in val1.surfaces:
          _x = val2.name
          length = len(_x)
          if python3 or type(_x) == unicode:
            _x = _x.encode('utf-8')
            length = len(_x)
          if python3:
            buff.write(struct.pack('<I%sB'%length, length, *_x))
          else:
            buff.write(struct.pack('<I%ss'%length, length, _x))
          _x = val2
          buff.write(_struct_2d.pack(_x.width, _x.height))
          _v22 = val2.pose
          _v23 = _v22.position
          _x = _v23
          buff.write(_struct_3d.pack(_x.x, _x.y, _x.z))
          _v24 = _v22.orientation
          _x = _v24
          buff.write(_struct_4d.pack(_x.x, _x.y, _x.z, _x.w))
          length = len(val2.pois)
          buff.write(_struct_I.pack(length))
          for val3 in val2.pois:
            _x = val3.name
            length = len(_x)
            if python3 or type(_x) == unicode:
              _x = _x.encode('utf-8')
              length = len(_x)
            if python3:
              buff.write(struct.pack('<I%sB'%length, length, *_x))
            else:
              buff.write(struct.pack('<I%ss'%length, length, _x))
            _x = val3
            buff.write(_struct_2d.pack(_x.width, _x.height))
            _v25 = val3.pose
            _v26 = _v25.position
            _x = _v26
            buff.write(_struct_3d.pack(_x.x, _x.y, _x.z))
            _v27 = _v25.orientation
            _x = _v27
            buff.write(_struct_4d.pack(_x.x, _x.y, _x.z, _x.w))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize_numpy(self, str, numpy):
    """
    unpack serialized message in str into this message instance using numpy for array types
    :param str: byte array of serialized message, ``str``
    :param numpy: numpy python module
    """
    try:
      if self.items is None:
        self.items = None
      if self.rooms is None:
        self.rooms = None
      end = 0
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.task = str[start:end].decode('utf-8')
      else:
        self.task = str[start:end]
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.items = []
      for i in range(0, length):
        val1 = interactive_world_msgs.msg.Item()
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          val1.name = str[start:end].decode('utf-8')
        else:
          val1.name = str[start:end]
        _x = val1
        start = end
        end += 16
        (_x.width, _x.height,) = _struct_2d.unpack(str[start:end])
        self.items.append(val1)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.rooms = []
      for i in range(0, length):
        val1 = interactive_world_msgs.msg.Room()
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          val1.name = str[start:end].decode('utf-8')
        else:
          val1.name = str[start:end]
        _x = val1
        start = end
        end += 16
        (_x.width, _x.height,) = _struct_2d.unpack(str[start:end])
        _v28 = val1.pose
        _v29 = _v28.position
        _x = _v29
        start = end
        end += 24
        (_x.x, _x.y, _x.z,) = _struct_3d.unpack(str[start:end])
        _v30 = _v28.orientation
        _x = _v30
        start = end
        end += 32
        (_x.x, _x.y, _x.z, _x.w,) = _struct_4d.unpack(str[start:end])
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        val1.surfaces = []
        for i in range(0, length):
          val2 = interactive_world_msgs.msg.Surface()
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          start = end
          end += length
          if python3:
            val2.name = str[start:end].decode('utf-8')
          else:
            val2.name = str[start:end]
          _x = val2
          start = end
          end += 16
          (_x.width, _x.height,) = _struct_2d.unpack(str[start:end])
          _v31 = val2.pose
          _v32 = _v31.position
          _x = _v32
          start = end
          end += 24
          (_x.x, _x.y, _x.z,) = _struct_3d.unpack(str[start:end])
          _v33 = _v31.orientation
          _x = _v33
          start = end
          end += 32
          (_x.x, _x.y, _x.z, _x.w,) = _struct_4d.unpack(str[start:end])
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          val2.pois = []
          for i in range(0, length):
            val3 = interactive_world_msgs.msg.PointOfInterest()
            start = end
            end += 4
            (length,) = _struct_I.unpack(str[start:end])
            start = end
            end += length
            if python3:
              val3.name = str[start:end].decode('utf-8')
            else:
              val3.name = str[start:end]
            _x = val3
            start = end
            end += 16
            (_x.width, _x.height,) = _struct_2d.unpack(str[start:end])
            _v34 = val3.pose
            _v35 = _v34.position
            _x = _v35
            start = end
            end += 24
            (_x.x, _x.y, _x.z,) = _struct_3d.unpack(str[start:end])
            _v36 = _v34.orientation
            _x = _v36
            start = end
            end += 32
            (_x.x, _x.y, _x.z, _x.w,) = _struct_4d.unpack(str[start:end])
            val2.pois.append(val3)
          val1.surfaces.append(val2)
        self.rooms.append(val1)
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e) #most likely buffer underfill

_struct_I = genpy.struct_I
_struct_2d = struct.Struct("<2d")
_struct_4d = struct.Struct("<4d")
_struct_3d = struct.Struct("<3d")
