# This Python file uses the following encoding: utf-8
"""autogenerated by genpy from interactive_world_msgs/PlacementSet.msg. Do not edit."""
import sys
python3 = True if sys.hexversion > 0x03000000 else False
import genpy
import struct

import geometry_msgs.msg
import interactive_world_msgs.msg

class PlacementSet(genpy.Message):
  _md5sum = "7bc61d4164a3ca3362d52bfb47f837f5"
  _type = "interactive_world_msgs/PlacementSet"
  _has_header = False #flag to mark the presence of a Header object
  _full_text = """interactive_world_msgs/Item item                 # item placed in the placement set
interactive_world_msgs/Room room                 # the room the item is placed in
interactive_world_msgs/Surface surface           # the surface the item is placed on
string reference_frame_id                        # name of the target reference frame for the placement set
interactive_world_msgs/Placement[] placements    # the set of placements

================================================================================
MSG: interactive_world_msgs/Item
string name       # name of the object
float64 width     # width of the object in meters (along the x-axis)
float64 height    # height of the object in meters (along the y-axis)

================================================================================
MSG: interactive_world_msgs/Room
string name                                  # name of the room
float64 width                                # width of the room in meters (along the x-axis)
float64 height                               # height of the room in meters (along the y-axis)
geometry_msgs/Pose pose                      # the position of the room relative to the world
interactive_world_msgs/Surface[] surfaces    # surfaces in the room

================================================================================
MSG: geometry_msgs/Pose
# A representation of pose in free space, composed of postion and orientation. 
Point position
Quaternion orientation

================================================================================
MSG: geometry_msgs/Point
# This contains the position of a point in free space
float64 x
float64 y
float64 z

================================================================================
MSG: geometry_msgs/Quaternion
# This represents an orientation in free space in quaternion form.

float64 x
float64 y
float64 z
float64 w

================================================================================
MSG: interactive_world_msgs/Surface
string name                                      # name of the surface
float64 width                                    # width of the surface in meters (along the x-axis)
float64 height                                   # height of the surface in meters (along the y-axis)
geometry_msgs/Pose pose                          # the position of the surface relative to its parent room
interactive_world_msgs/PointOfInterest[] pois    # POIs for the surface

================================================================================
MSG: interactive_world_msgs/PointOfInterest
string name                # name of the POI
float64 width              # width of the POI in meters (along the x-axis)
float64 height             # height of the POI in meters (along the y-axis)
geometry_msgs/Pose pose    # the position of the POI relative to its parent furniture

================================================================================
MSG: interactive_world_msgs/Placement
interactive_world_msgs/Item item          # item placed in the placement
interactive_world_msgs/Room room          # the room the item is placed in
interactive_world_msgs/Surface surface    # the surface the item is placed on
string reference_frame_id                 # name of the target reference frame for the placement
geometry_msgs/Point position              # position of the placement
float64 rotation                          # rotation of the placement (along the z-axis)
"""
  __slots__ = ['item','room','surface','reference_frame_id','placements']
  _slot_types = ['interactive_world_msgs/Item','interactive_world_msgs/Room','interactive_world_msgs/Surface','string','interactive_world_msgs/Placement[]']

  def __init__(self, *args, **kwds):
    """
    Constructor. Any message fields that are implicitly/explicitly
    set to None will be assigned a default value. The recommend
    use is keyword arguments as this is more robust to future message
    changes.  You cannot mix in-order arguments and keyword arguments.

    The available fields are:
       item,room,surface,reference_frame_id,placements

    :param args: complete set of field values, in .msg order
    :param kwds: use keyword arguments corresponding to message field names
    to set specific fields.
    """
    if args or kwds:
      super(PlacementSet, self).__init__(*args, **kwds)
      #message fields cannot be None, assign default values for those that are
      if self.item is None:
        self.item = interactive_world_msgs.msg.Item()
      if self.room is None:
        self.room = interactive_world_msgs.msg.Room()
      if self.surface is None:
        self.surface = interactive_world_msgs.msg.Surface()
      if self.reference_frame_id is None:
        self.reference_frame_id = ''
      if self.placements is None:
        self.placements = []
    else:
      self.item = interactive_world_msgs.msg.Item()
      self.room = interactive_world_msgs.msg.Room()
      self.surface = interactive_world_msgs.msg.Surface()
      self.reference_frame_id = ''
      self.placements = []

  def _get_types(self):
    """
    internal API method
    """
    return self._slot_types

  def serialize(self, buff):
    """
    serialize message into buffer
    :param buff: buffer, ``StringIO``
    """
    try:
      _x = self.item.name
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      if python3:
        buff.write(struct.pack('<I%sB'%length, length, *_x))
      else:
        buff.write(struct.pack('<I%ss'%length, length, _x))
      _x = self
      buff.write(_struct_2d.pack(_x.item.width, _x.item.height))
      _x = self.room.name
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      if python3:
        buff.write(struct.pack('<I%sB'%length, length, *_x))
      else:
        buff.write(struct.pack('<I%ss'%length, length, _x))
      _x = self
      buff.write(_struct_9d.pack(_x.room.width, _x.room.height, _x.room.pose.position.x, _x.room.pose.position.y, _x.room.pose.position.z, _x.room.pose.orientation.x, _x.room.pose.orientation.y, _x.room.pose.orientation.z, _x.room.pose.orientation.w))
      length = len(self.room.surfaces)
      buff.write(_struct_I.pack(length))
      for val1 in self.room.surfaces:
        _x = val1.name
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        if python3:
          buff.write(struct.pack('<I%sB'%length, length, *_x))
        else:
          buff.write(struct.pack('<I%ss'%length, length, _x))
        _x = val1
        buff.write(_struct_2d.pack(_x.width, _x.height))
        _v1 = val1.pose
        _v2 = _v1.position
        _x = _v2
        buff.write(_struct_3d.pack(_x.x, _x.y, _x.z))
        _v3 = _v1.orientation
        _x = _v3
        buff.write(_struct_4d.pack(_x.x, _x.y, _x.z, _x.w))
        length = len(val1.pois)
        buff.write(_struct_I.pack(length))
        for val2 in val1.pois:
          _x = val2.name
          length = len(_x)
          if python3 or type(_x) == unicode:
            _x = _x.encode('utf-8')
            length = len(_x)
          if python3:
            buff.write(struct.pack('<I%sB'%length, length, *_x))
          else:
            buff.write(struct.pack('<I%ss'%length, length, _x))
          _x = val2
          buff.write(_struct_2d.pack(_x.width, _x.height))
          _v4 = val2.pose
          _v5 = _v4.position
          _x = _v5
          buff.write(_struct_3d.pack(_x.x, _x.y, _x.z))
          _v6 = _v4.orientation
          _x = _v6
          buff.write(_struct_4d.pack(_x.x, _x.y, _x.z, _x.w))
      _x = self.surface.name
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      if python3:
        buff.write(struct.pack('<I%sB'%length, length, *_x))
      else:
        buff.write(struct.pack('<I%ss'%length, length, _x))
      _x = self
      buff.write(_struct_9d.pack(_x.surface.width, _x.surface.height, _x.surface.pose.position.x, _x.surface.pose.position.y, _x.surface.pose.position.z, _x.surface.pose.orientation.x, _x.surface.pose.orientation.y, _x.surface.pose.orientation.z, _x.surface.pose.orientation.w))
      length = len(self.surface.pois)
      buff.write(_struct_I.pack(length))
      for val1 in self.surface.pois:
        _x = val1.name
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        if python3:
          buff.write(struct.pack('<I%sB'%length, length, *_x))
        else:
          buff.write(struct.pack('<I%ss'%length, length, _x))
        _x = val1
        buff.write(_struct_2d.pack(_x.width, _x.height))
        _v7 = val1.pose
        _v8 = _v7.position
        _x = _v8
        buff.write(_struct_3d.pack(_x.x, _x.y, _x.z))
        _v9 = _v7.orientation
        _x = _v9
        buff.write(_struct_4d.pack(_x.x, _x.y, _x.z, _x.w))
      _x = self.reference_frame_id
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      if python3:
        buff.write(struct.pack('<I%sB'%length, length, *_x))
      else:
        buff.write(struct.pack('<I%ss'%length, length, _x))
      length = len(self.placements)
      buff.write(_struct_I.pack(length))
      for val1 in self.placements:
        _v10 = val1.item
        _x = _v10.name
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        if python3:
          buff.write(struct.pack('<I%sB'%length, length, *_x))
        else:
          buff.write(struct.pack('<I%ss'%length, length, _x))
        _x = _v10
        buff.write(_struct_2d.pack(_x.width, _x.height))
        _v11 = val1.room
        _x = _v11.name
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        if python3:
          buff.write(struct.pack('<I%sB'%length, length, *_x))
        else:
          buff.write(struct.pack('<I%ss'%length, length, _x))
        _x = _v11
        buff.write(_struct_2d.pack(_x.width, _x.height))
        _v12 = _v11.pose
        _v13 = _v12.position
        _x = _v13
        buff.write(_struct_3d.pack(_x.x, _x.y, _x.z))
        _v14 = _v12.orientation
        _x = _v14
        buff.write(_struct_4d.pack(_x.x, _x.y, _x.z, _x.w))
        length = len(_v11.surfaces)
        buff.write(_struct_I.pack(length))
        for val3 in _v11.surfaces:
          _x = val3.name
          length = len(_x)
          if python3 or type(_x) == unicode:
            _x = _x.encode('utf-8')
            length = len(_x)
          if python3:
            buff.write(struct.pack('<I%sB'%length, length, *_x))
          else:
            buff.write(struct.pack('<I%ss'%length, length, _x))
          _x = val3
          buff.write(_struct_2d.pack(_x.width, _x.height))
          _v15 = val3.pose
          _v16 = _v15.position
          _x = _v16
          buff.write(_struct_3d.pack(_x.x, _x.y, _x.z))
          _v17 = _v15.orientation
          _x = _v17
          buff.write(_struct_4d.pack(_x.x, _x.y, _x.z, _x.w))
          length = len(val3.pois)
          buff.write(_struct_I.pack(length))
          for val4 in val3.pois:
            _x = val4.name
            length = len(_x)
            if python3 or type(_x) == unicode:
              _x = _x.encode('utf-8')
              length = len(_x)
            if python3:
              buff.write(struct.pack('<I%sB'%length, length, *_x))
            else:
              buff.write(struct.pack('<I%ss'%length, length, _x))
            _x = val4
            buff.write(_struct_2d.pack(_x.width, _x.height))
            _v18 = val4.pose
            _v19 = _v18.position
            _x = _v19
            buff.write(_struct_3d.pack(_x.x, _x.y, _x.z))
            _v20 = _v18.orientation
            _x = _v20
            buff.write(_struct_4d.pack(_x.x, _x.y, _x.z, _x.w))
        _v21 = val1.surface
        _x = _v21.name
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        if python3:
          buff.write(struct.pack('<I%sB'%length, length, *_x))
        else:
          buff.write(struct.pack('<I%ss'%length, length, _x))
        _x = _v21
        buff.write(_struct_2d.pack(_x.width, _x.height))
        _v22 = _v21.pose
        _v23 = _v22.position
        _x = _v23
        buff.write(_struct_3d.pack(_x.x, _x.y, _x.z))
        _v24 = _v22.orientation
        _x = _v24
        buff.write(_struct_4d.pack(_x.x, _x.y, _x.z, _x.w))
        length = len(_v21.pois)
        buff.write(_struct_I.pack(length))
        for val3 in _v21.pois:
          _x = val3.name
          length = len(_x)
          if python3 or type(_x) == unicode:
            _x = _x.encode('utf-8')
            length = len(_x)
          if python3:
            buff.write(struct.pack('<I%sB'%length, length, *_x))
          else:
            buff.write(struct.pack('<I%ss'%length, length, _x))
          _x = val3
          buff.write(_struct_2d.pack(_x.width, _x.height))
          _v25 = val3.pose
          _v26 = _v25.position
          _x = _v26
          buff.write(_struct_3d.pack(_x.x, _x.y, _x.z))
          _v27 = _v25.orientation
          _x = _v27
          buff.write(_struct_4d.pack(_x.x, _x.y, _x.z, _x.w))
        _x = val1.reference_frame_id
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        if python3:
          buff.write(struct.pack('<I%sB'%length, length, *_x))
        else:
          buff.write(struct.pack('<I%ss'%length, length, _x))
        _v28 = val1.position
        _x = _v28
        buff.write(_struct_3d.pack(_x.x, _x.y, _x.z))
        buff.write(_struct_d.pack(val1.rotation))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize(self, str):
    """
    unpack serialized message in str into this message instance
    :param str: byte array of serialized message, ``str``
    """
    try:
      if self.item is None:
        self.item = interactive_world_msgs.msg.Item()
      if self.room is None:
        self.room = interactive_world_msgs.msg.Room()
      if self.surface is None:
        self.surface = interactive_world_msgs.msg.Surface()
      if self.placements is None:
        self.placements = None
      end = 0
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.item.name = str[start:end].decode('utf-8')
      else:
        self.item.name = str[start:end]
      _x = self
      start = end
      end += 16
      (_x.item.width, _x.item.height,) = _struct_2d.unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.room.name = str[start:end].decode('utf-8')
      else:
        self.room.name = str[start:end]
      _x = self
      start = end
      end += 72
      (_x.room.width, _x.room.height, _x.room.pose.position.x, _x.room.pose.position.y, _x.room.pose.position.z, _x.room.pose.orientation.x, _x.room.pose.orientation.y, _x.room.pose.orientation.z, _x.room.pose.orientation.w,) = _struct_9d.unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.room.surfaces = []
      for i in range(0, length):
        val1 = interactive_world_msgs.msg.Surface()
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          val1.name = str[start:end].decode('utf-8')
        else:
          val1.name = str[start:end]
        _x = val1
        start = end
        end += 16
        (_x.width, _x.height,) = _struct_2d.unpack(str[start:end])
        _v29 = val1.pose
        _v30 = _v29.position
        _x = _v30
        start = end
        end += 24
        (_x.x, _x.y, _x.z,) = _struct_3d.unpack(str[start:end])
        _v31 = _v29.orientation
        _x = _v31
        start = end
        end += 32
        (_x.x, _x.y, _x.z, _x.w,) = _struct_4d.unpack(str[start:end])
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        val1.pois = []
        for i in range(0, length):
          val2 = interactive_world_msgs.msg.PointOfInterest()
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          start = end
          end += length
          if python3:
            val2.name = str[start:end].decode('utf-8')
          else:
            val2.name = str[start:end]
          _x = val2
          start = end
          end += 16
          (_x.width, _x.height,) = _struct_2d.unpack(str[start:end])
          _v32 = val2.pose
          _v33 = _v32.position
          _x = _v33
          start = end
          end += 24
          (_x.x, _x.y, _x.z,) = _struct_3d.unpack(str[start:end])
          _v34 = _v32.orientation
          _x = _v34
          start = end
          end += 32
          (_x.x, _x.y, _x.z, _x.w,) = _struct_4d.unpack(str[start:end])
          val1.pois.append(val2)
        self.room.surfaces.append(val1)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.surface.name = str[start:end].decode('utf-8')
      else:
        self.surface.name = str[start:end]
      _x = self
      start = end
      end += 72
      (_x.surface.width, _x.surface.height, _x.surface.pose.position.x, _x.surface.pose.position.y, _x.surface.pose.position.z, _x.surface.pose.orientation.x, _x.surface.pose.orientation.y, _x.surface.pose.orientation.z, _x.surface.pose.orientation.w,) = _struct_9d.unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.surface.pois = []
      for i in range(0, length):
        val1 = interactive_world_msgs.msg.PointOfInterest()
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          val1.name = str[start:end].decode('utf-8')
        else:
          val1.name = str[start:end]
        _x = val1
        start = end
        end += 16
        (_x.width, _x.height,) = _struct_2d.unpack(str[start:end])
        _v35 = val1.pose
        _v36 = _v35.position
        _x = _v36
        start = end
        end += 24
        (_x.x, _x.y, _x.z,) = _struct_3d.unpack(str[start:end])
        _v37 = _v35.orientation
        _x = _v37
        start = end
        end += 32
        (_x.x, _x.y, _x.z, _x.w,) = _struct_4d.unpack(str[start:end])
        self.surface.pois.append(val1)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.reference_frame_id = str[start:end].decode('utf-8')
      else:
        self.reference_frame_id = str[start:end]
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.placements = []
      for i in range(0, length):
        val1 = interactive_world_msgs.msg.Placement()
        _v38 = val1.item
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          _v38.name = str[start:end].decode('utf-8')
        else:
          _v38.name = str[start:end]
        _x = _v38
        start = end
        end += 16
        (_x.width, _x.height,) = _struct_2d.unpack(str[start:end])
        _v39 = val1.room
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          _v39.name = str[start:end].decode('utf-8')
        else:
          _v39.name = str[start:end]
        _x = _v39
        start = end
        end += 16
        (_x.width, _x.height,) = _struct_2d.unpack(str[start:end])
        _v40 = _v39.pose
        _v41 = _v40.position
        _x = _v41
        start = end
        end += 24
        (_x.x, _x.y, _x.z,) = _struct_3d.unpack(str[start:end])
        _v42 = _v40.orientation
        _x = _v42
        start = end
        end += 32
        (_x.x, _x.y, _x.z, _x.w,) = _struct_4d.unpack(str[start:end])
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        _v39.surfaces = []
        for i in range(0, length):
          val3 = interactive_world_msgs.msg.Surface()
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          start = end
          end += length
          if python3:
            val3.name = str[start:end].decode('utf-8')
          else:
            val3.name = str[start:end]
          _x = val3
          start = end
          end += 16
          (_x.width, _x.height,) = _struct_2d.unpack(str[start:end])
          _v43 = val3.pose
          _v44 = _v43.position
          _x = _v44
          start = end
          end += 24
          (_x.x, _x.y, _x.z,) = _struct_3d.unpack(str[start:end])
          _v45 = _v43.orientation
          _x = _v45
          start = end
          end += 32
          (_x.x, _x.y, _x.z, _x.w,) = _struct_4d.unpack(str[start:end])
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          val3.pois = []
          for i in range(0, length):
            val4 = interactive_world_msgs.msg.PointOfInterest()
            start = end
            end += 4
            (length,) = _struct_I.unpack(str[start:end])
            start = end
            end += length
            if python3:
              val4.name = str[start:end].decode('utf-8')
            else:
              val4.name = str[start:end]
            _x = val4
            start = end
            end += 16
            (_x.width, _x.height,) = _struct_2d.unpack(str[start:end])
            _v46 = val4.pose
            _v47 = _v46.position
            _x = _v47
            start = end
            end += 24
            (_x.x, _x.y, _x.z,) = _struct_3d.unpack(str[start:end])
            _v48 = _v46.orientation
            _x = _v48
            start = end
            end += 32
            (_x.x, _x.y, _x.z, _x.w,) = _struct_4d.unpack(str[start:end])
            val3.pois.append(val4)
          _v39.surfaces.append(val3)
        _v49 = val1.surface
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          _v49.name = str[start:end].decode('utf-8')
        else:
          _v49.name = str[start:end]
        _x = _v49
        start = end
        end += 16
        (_x.width, _x.height,) = _struct_2d.unpack(str[start:end])
        _v50 = _v49.pose
        _v51 = _v50.position
        _x = _v51
        start = end
        end += 24
        (_x.x, _x.y, _x.z,) = _struct_3d.unpack(str[start:end])
        _v52 = _v50.orientation
        _x = _v52
        start = end
        end += 32
        (_x.x, _x.y, _x.z, _x.w,) = _struct_4d.unpack(str[start:end])
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        _v49.pois = []
        for i in range(0, length):
          val3 = interactive_world_msgs.msg.PointOfInterest()
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          start = end
          end += length
          if python3:
            val3.name = str[start:end].decode('utf-8')
          else:
            val3.name = str[start:end]
          _x = val3
          start = end
          end += 16
          (_x.width, _x.height,) = _struct_2d.unpack(str[start:end])
          _v53 = val3.pose
          _v54 = _v53.position
          _x = _v54
          start = end
          end += 24
          (_x.x, _x.y, _x.z,) = _struct_3d.unpack(str[start:end])
          _v55 = _v53.orientation
          _x = _v55
          start = end
          end += 32
          (_x.x, _x.y, _x.z, _x.w,) = _struct_4d.unpack(str[start:end])
          _v49.pois.append(val3)
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          val1.reference_frame_id = str[start:end].decode('utf-8')
        else:
          val1.reference_frame_id = str[start:end]
        _v56 = val1.position
        _x = _v56
        start = end
        end += 24
        (_x.x, _x.y, _x.z,) = _struct_3d.unpack(str[start:end])
        start = end
        end += 8
        (val1.rotation,) = _struct_d.unpack(str[start:end])
        self.placements.append(val1)
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e) #most likely buffer underfill


  def serialize_numpy(self, buff, numpy):
    """
    serialize message with numpy array types into buffer
    :param buff: buffer, ``StringIO``
    :param numpy: numpy python module
    """
    try:
      _x = self.item.name
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      if python3:
        buff.write(struct.pack('<I%sB'%length, length, *_x))
      else:
        buff.write(struct.pack('<I%ss'%length, length, _x))
      _x = self
      buff.write(_struct_2d.pack(_x.item.width, _x.item.height))
      _x = self.room.name
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      if python3:
        buff.write(struct.pack('<I%sB'%length, length, *_x))
      else:
        buff.write(struct.pack('<I%ss'%length, length, _x))
      _x = self
      buff.write(_struct_9d.pack(_x.room.width, _x.room.height, _x.room.pose.position.x, _x.room.pose.position.y, _x.room.pose.position.z, _x.room.pose.orientation.x, _x.room.pose.orientation.y, _x.room.pose.orientation.z, _x.room.pose.orientation.w))
      length = len(self.room.surfaces)
      buff.write(_struct_I.pack(length))
      for val1 in self.room.surfaces:
        _x = val1.name
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        if python3:
          buff.write(struct.pack('<I%sB'%length, length, *_x))
        else:
          buff.write(struct.pack('<I%ss'%length, length, _x))
        _x = val1
        buff.write(_struct_2d.pack(_x.width, _x.height))
        _v57 = val1.pose
        _v58 = _v57.position
        _x = _v58
        buff.write(_struct_3d.pack(_x.x, _x.y, _x.z))
        _v59 = _v57.orientation
        _x = _v59
        buff.write(_struct_4d.pack(_x.x, _x.y, _x.z, _x.w))
        length = len(val1.pois)
        buff.write(_struct_I.pack(length))
        for val2 in val1.pois:
          _x = val2.name
          length = len(_x)
          if python3 or type(_x) == unicode:
            _x = _x.encode('utf-8')
            length = len(_x)
          if python3:
            buff.write(struct.pack('<I%sB'%length, length, *_x))
          else:
            buff.write(struct.pack('<I%ss'%length, length, _x))
          _x = val2
          buff.write(_struct_2d.pack(_x.width, _x.height))
          _v60 = val2.pose
          _v61 = _v60.position
          _x = _v61
          buff.write(_struct_3d.pack(_x.x, _x.y, _x.z))
          _v62 = _v60.orientation
          _x = _v62
          buff.write(_struct_4d.pack(_x.x, _x.y, _x.z, _x.w))
      _x = self.surface.name
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      if python3:
        buff.write(struct.pack('<I%sB'%length, length, *_x))
      else:
        buff.write(struct.pack('<I%ss'%length, length, _x))
      _x = self
      buff.write(_struct_9d.pack(_x.surface.width, _x.surface.height, _x.surface.pose.position.x, _x.surface.pose.position.y, _x.surface.pose.position.z, _x.surface.pose.orientation.x, _x.surface.pose.orientation.y, _x.surface.pose.orientation.z, _x.surface.pose.orientation.w))
      length = len(self.surface.pois)
      buff.write(_struct_I.pack(length))
      for val1 in self.surface.pois:
        _x = val1.name
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        if python3:
          buff.write(struct.pack('<I%sB'%length, length, *_x))
        else:
          buff.write(struct.pack('<I%ss'%length, length, _x))
        _x = val1
        buff.write(_struct_2d.pack(_x.width, _x.height))
        _v63 = val1.pose
        _v64 = _v63.position
        _x = _v64
        buff.write(_struct_3d.pack(_x.x, _x.y, _x.z))
        _v65 = _v63.orientation
        _x = _v65
        buff.write(_struct_4d.pack(_x.x, _x.y, _x.z, _x.w))
      _x = self.reference_frame_id
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      if python3:
        buff.write(struct.pack('<I%sB'%length, length, *_x))
      else:
        buff.write(struct.pack('<I%ss'%length, length, _x))
      length = len(self.placements)
      buff.write(_struct_I.pack(length))
      for val1 in self.placements:
        _v66 = val1.item
        _x = _v66.name
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        if python3:
          buff.write(struct.pack('<I%sB'%length, length, *_x))
        else:
          buff.write(struct.pack('<I%ss'%length, length, _x))
        _x = _v66
        buff.write(_struct_2d.pack(_x.width, _x.height))
        _v67 = val1.room
        _x = _v67.name
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        if python3:
          buff.write(struct.pack('<I%sB'%length, length, *_x))
        else:
          buff.write(struct.pack('<I%ss'%length, length, _x))
        _x = _v67
        buff.write(_struct_2d.pack(_x.width, _x.height))
        _v68 = _v67.pose
        _v69 = _v68.position
        _x = _v69
        buff.write(_struct_3d.pack(_x.x, _x.y, _x.z))
        _v70 = _v68.orientation
        _x = _v70
        buff.write(_struct_4d.pack(_x.x, _x.y, _x.z, _x.w))
        length = len(_v67.surfaces)
        buff.write(_struct_I.pack(length))
        for val3 in _v67.surfaces:
          _x = val3.name
          length = len(_x)
          if python3 or type(_x) == unicode:
            _x = _x.encode('utf-8')
            length = len(_x)
          if python3:
            buff.write(struct.pack('<I%sB'%length, length, *_x))
          else:
            buff.write(struct.pack('<I%ss'%length, length, _x))
          _x = val3
          buff.write(_struct_2d.pack(_x.width, _x.height))
          _v71 = val3.pose
          _v72 = _v71.position
          _x = _v72
          buff.write(_struct_3d.pack(_x.x, _x.y, _x.z))
          _v73 = _v71.orientation
          _x = _v73
          buff.write(_struct_4d.pack(_x.x, _x.y, _x.z, _x.w))
          length = len(val3.pois)
          buff.write(_struct_I.pack(length))
          for val4 in val3.pois:
            _x = val4.name
            length = len(_x)
            if python3 or type(_x) == unicode:
              _x = _x.encode('utf-8')
              length = len(_x)
            if python3:
              buff.write(struct.pack('<I%sB'%length, length, *_x))
            else:
              buff.write(struct.pack('<I%ss'%length, length, _x))
            _x = val4
            buff.write(_struct_2d.pack(_x.width, _x.height))
            _v74 = val4.pose
            _v75 = _v74.position
            _x = _v75
            buff.write(_struct_3d.pack(_x.x, _x.y, _x.z))
            _v76 = _v74.orientation
            _x = _v76
            buff.write(_struct_4d.pack(_x.x, _x.y, _x.z, _x.w))
        _v77 = val1.surface
        _x = _v77.name
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        if python3:
          buff.write(struct.pack('<I%sB'%length, length, *_x))
        else:
          buff.write(struct.pack('<I%ss'%length, length, _x))
        _x = _v77
        buff.write(_struct_2d.pack(_x.width, _x.height))
        _v78 = _v77.pose
        _v79 = _v78.position
        _x = _v79
        buff.write(_struct_3d.pack(_x.x, _x.y, _x.z))
        _v80 = _v78.orientation
        _x = _v80
        buff.write(_struct_4d.pack(_x.x, _x.y, _x.z, _x.w))
        length = len(_v77.pois)
        buff.write(_struct_I.pack(length))
        for val3 in _v77.pois:
          _x = val3.name
          length = len(_x)
          if python3 or type(_x) == unicode:
            _x = _x.encode('utf-8')
            length = len(_x)
          if python3:
            buff.write(struct.pack('<I%sB'%length, length, *_x))
          else:
            buff.write(struct.pack('<I%ss'%length, length, _x))
          _x = val3
          buff.write(_struct_2d.pack(_x.width, _x.height))
          _v81 = val3.pose
          _v82 = _v81.position
          _x = _v82
          buff.write(_struct_3d.pack(_x.x, _x.y, _x.z))
          _v83 = _v81.orientation
          _x = _v83
          buff.write(_struct_4d.pack(_x.x, _x.y, _x.z, _x.w))
        _x = val1.reference_frame_id
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        if python3:
          buff.write(struct.pack('<I%sB'%length, length, *_x))
        else:
          buff.write(struct.pack('<I%ss'%length, length, _x))
        _v84 = val1.position
        _x = _v84
        buff.write(_struct_3d.pack(_x.x, _x.y, _x.z))
        buff.write(_struct_d.pack(val1.rotation))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize_numpy(self, str, numpy):
    """
    unpack serialized message in str into this message instance using numpy for array types
    :param str: byte array of serialized message, ``str``
    :param numpy: numpy python module
    """
    try:
      if self.item is None:
        self.item = interactive_world_msgs.msg.Item()
      if self.room is None:
        self.room = interactive_world_msgs.msg.Room()
      if self.surface is None:
        self.surface = interactive_world_msgs.msg.Surface()
      if self.placements is None:
        self.placements = None
      end = 0
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.item.name = str[start:end].decode('utf-8')
      else:
        self.item.name = str[start:end]
      _x = self
      start = end
      end += 16
      (_x.item.width, _x.item.height,) = _struct_2d.unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.room.name = str[start:end].decode('utf-8')
      else:
        self.room.name = str[start:end]
      _x = self
      start = end
      end += 72
      (_x.room.width, _x.room.height, _x.room.pose.position.x, _x.room.pose.position.y, _x.room.pose.position.z, _x.room.pose.orientation.x, _x.room.pose.orientation.y, _x.room.pose.orientation.z, _x.room.pose.orientation.w,) = _struct_9d.unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.room.surfaces = []
      for i in range(0, length):
        val1 = interactive_world_msgs.msg.Surface()
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          val1.name = str[start:end].decode('utf-8')
        else:
          val1.name = str[start:end]
        _x = val1
        start = end
        end += 16
        (_x.width, _x.height,) = _struct_2d.unpack(str[start:end])
        _v85 = val1.pose
        _v86 = _v85.position
        _x = _v86
        start = end
        end += 24
        (_x.x, _x.y, _x.z,) = _struct_3d.unpack(str[start:end])
        _v87 = _v85.orientation
        _x = _v87
        start = end
        end += 32
        (_x.x, _x.y, _x.z, _x.w,) = _struct_4d.unpack(str[start:end])
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        val1.pois = []
        for i in range(0, length):
          val2 = interactive_world_msgs.msg.PointOfInterest()
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          start = end
          end += length
          if python3:
            val2.name = str[start:end].decode('utf-8')
          else:
            val2.name = str[start:end]
          _x = val2
          start = end
          end += 16
          (_x.width, _x.height,) = _struct_2d.unpack(str[start:end])
          _v88 = val2.pose
          _v89 = _v88.position
          _x = _v89
          start = end
          end += 24
          (_x.x, _x.y, _x.z,) = _struct_3d.unpack(str[start:end])
          _v90 = _v88.orientation
          _x = _v90
          start = end
          end += 32
          (_x.x, _x.y, _x.z, _x.w,) = _struct_4d.unpack(str[start:end])
          val1.pois.append(val2)
        self.room.surfaces.append(val1)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.surface.name = str[start:end].decode('utf-8')
      else:
        self.surface.name = str[start:end]
      _x = self
      start = end
      end += 72
      (_x.surface.width, _x.surface.height, _x.surface.pose.position.x, _x.surface.pose.position.y, _x.surface.pose.position.z, _x.surface.pose.orientation.x, _x.surface.pose.orientation.y, _x.surface.pose.orientation.z, _x.surface.pose.orientation.w,) = _struct_9d.unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.surface.pois = []
      for i in range(0, length):
        val1 = interactive_world_msgs.msg.PointOfInterest()
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          val1.name = str[start:end].decode('utf-8')
        else:
          val1.name = str[start:end]
        _x = val1
        start = end
        end += 16
        (_x.width, _x.height,) = _struct_2d.unpack(str[start:end])
        _v91 = val1.pose
        _v92 = _v91.position
        _x = _v92
        start = end
        end += 24
        (_x.x, _x.y, _x.z,) = _struct_3d.unpack(str[start:end])
        _v93 = _v91.orientation
        _x = _v93
        start = end
        end += 32
        (_x.x, _x.y, _x.z, _x.w,) = _struct_4d.unpack(str[start:end])
        self.surface.pois.append(val1)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.reference_frame_id = str[start:end].decode('utf-8')
      else:
        self.reference_frame_id = str[start:end]
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.placements = []
      for i in range(0, length):
        val1 = interactive_world_msgs.msg.Placement()
        _v94 = val1.item
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          _v94.name = str[start:end].decode('utf-8')
        else:
          _v94.name = str[start:end]
        _x = _v94
        start = end
        end += 16
        (_x.width, _x.height,) = _struct_2d.unpack(str[start:end])
        _v95 = val1.room
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          _v95.name = str[start:end].decode('utf-8')
        else:
          _v95.name = str[start:end]
        _x = _v95
        start = end
        end += 16
        (_x.width, _x.height,) = _struct_2d.unpack(str[start:end])
        _v96 = _v95.pose
        _v97 = _v96.position
        _x = _v97
        start = end
        end += 24
        (_x.x, _x.y, _x.z,) = _struct_3d.unpack(str[start:end])
        _v98 = _v96.orientation
        _x = _v98
        start = end
        end += 32
        (_x.x, _x.y, _x.z, _x.w,) = _struct_4d.unpack(str[start:end])
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        _v95.surfaces = []
        for i in range(0, length):
          val3 = interactive_world_msgs.msg.Surface()
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          start = end
          end += length
          if python3:
            val3.name = str[start:end].decode('utf-8')
          else:
            val3.name = str[start:end]
          _x = val3
          start = end
          end += 16
          (_x.width, _x.height,) = _struct_2d.unpack(str[start:end])
          _v99 = val3.pose
          _v100 = _v99.position
          _x = _v100
          start = end
          end += 24
          (_x.x, _x.y, _x.z,) = _struct_3d.unpack(str[start:end])
          _v101 = _v99.orientation
          _x = _v101
          start = end
          end += 32
          (_x.x, _x.y, _x.z, _x.w,) = _struct_4d.unpack(str[start:end])
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          val3.pois = []
          for i in range(0, length):
            val4 = interactive_world_msgs.msg.PointOfInterest()
            start = end
            end += 4
            (length,) = _struct_I.unpack(str[start:end])
            start = end
            end += length
            if python3:
              val4.name = str[start:end].decode('utf-8')
            else:
              val4.name = str[start:end]
            _x = val4
            start = end
            end += 16
            (_x.width, _x.height,) = _struct_2d.unpack(str[start:end])
            _v102 = val4.pose
            _v103 = _v102.position
            _x = _v103
            start = end
            end += 24
            (_x.x, _x.y, _x.z,) = _struct_3d.unpack(str[start:end])
            _v104 = _v102.orientation
            _x = _v104
            start = end
            end += 32
            (_x.x, _x.y, _x.z, _x.w,) = _struct_4d.unpack(str[start:end])
            val3.pois.append(val4)
          _v95.surfaces.append(val3)
        _v105 = val1.surface
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          _v105.name = str[start:end].decode('utf-8')
        else:
          _v105.name = str[start:end]
        _x = _v105
        start = end
        end += 16
        (_x.width, _x.height,) = _struct_2d.unpack(str[start:end])
        _v106 = _v105.pose
        _v107 = _v106.position
        _x = _v107
        start = end
        end += 24
        (_x.x, _x.y, _x.z,) = _struct_3d.unpack(str[start:end])
        _v108 = _v106.orientation
        _x = _v108
        start = end
        end += 32
        (_x.x, _x.y, _x.z, _x.w,) = _struct_4d.unpack(str[start:end])
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        _v105.pois = []
        for i in range(0, length):
          val3 = interactive_world_msgs.msg.PointOfInterest()
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          start = end
          end += length
          if python3:
            val3.name = str[start:end].decode('utf-8')
          else:
            val3.name = str[start:end]
          _x = val3
          start = end
          end += 16
          (_x.width, _x.height,) = _struct_2d.unpack(str[start:end])
          _v109 = val3.pose
          _v110 = _v109.position
          _x = _v110
          start = end
          end += 24
          (_x.x, _x.y, _x.z,) = _struct_3d.unpack(str[start:end])
          _v111 = _v109.orientation
          _x = _v111
          start = end
          end += 32
          (_x.x, _x.y, _x.z, _x.w,) = _struct_4d.unpack(str[start:end])
          _v105.pois.append(val3)
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          val1.reference_frame_id = str[start:end].decode('utf-8')
        else:
          val1.reference_frame_id = str[start:end]
        _v112 = val1.position
        _x = _v112
        start = end
        end += 24
        (_x.x, _x.y, _x.z,) = _struct_3d.unpack(str[start:end])
        start = end
        end += 8
        (val1.rotation,) = _struct_d.unpack(str[start:end])
        self.placements.append(val1)
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e) #most likely buffer underfill

_struct_I = genpy.struct_I
_struct_2d = struct.Struct("<2d")
_struct_d = struct.Struct("<d")
_struct_4d = struct.Struct("<4d")
_struct_9d = struct.Struct("<9d")
_struct_3d = struct.Struct("<3d")
