# This Python file uses the following encoding: utf-8
"""autogenerated by genpy from interactive_world_msgs/TaskTrainingData.msg. Do not edit."""
import sys
python3 = True if sys.hexversion > 0x03000000 else False
import genpy
import struct

import geometry_msgs.msg
import interactive_world_msgs.msg

class TaskTrainingData(genpy.Message):
  _md5sum = "7ff459157d004dd75750d4063a4b775d"
  _type = "interactive_world_msgs/TaskTrainingData"
  _has_header = False #flag to mark the presence of a Header object
  _full_text = """interactive_world_msgs/PlacementSet[] data     # all placement data for the task

================================================================================
MSG: interactive_world_msgs/PlacementSet
interactive_world_msgs/Item item                 # item placed in the placement set
interactive_world_msgs/Room room                 # the room the item is placed in
interactive_world_msgs/Surface surface           # the surface the item is placed on
string reference_frame_id                        # name of the target reference frame for the placement set
interactive_world_msgs/Placement[] placements    # the set of placements

================================================================================
MSG: interactive_world_msgs/Item
string name       # name of the object
float64 width     # width of the object in meters (along the x-axis)
float64 height    # height of the object in meters (along the y-axis)

================================================================================
MSG: interactive_world_msgs/Room
string name                                  # name of the room
float64 width                                # width of the room in meters (along the x-axis)
float64 height                               # height of the room in meters (along the y-axis)
geometry_msgs/Pose pose                      # the position of the room relative to the world
interactive_world_msgs/Surface[] surfaces    # surfaces in the room

================================================================================
MSG: geometry_msgs/Pose
# A representation of pose in free space, composed of postion and orientation. 
Point position
Quaternion orientation

================================================================================
MSG: geometry_msgs/Point
# This contains the position of a point in free space
float64 x
float64 y
float64 z

================================================================================
MSG: geometry_msgs/Quaternion
# This represents an orientation in free space in quaternion form.

float64 x
float64 y
float64 z
float64 w

================================================================================
MSG: interactive_world_msgs/Surface
string name                                      # name of the surface
float64 width                                    # width of the surface in meters (along the x-axis)
float64 height                                   # height of the surface in meters (along the y-axis)
geometry_msgs/Pose pose                          # the position of the surface relative to its parent room
interactive_world_msgs/PointOfInterest[] pois    # POIs for the surface

================================================================================
MSG: interactive_world_msgs/PointOfInterest
string name                # name of the POI
float64 width              # width of the POI in meters (along the x-axis)
float64 height             # height of the POI in meters (along the y-axis)
geometry_msgs/Pose pose    # the position of the POI relative to its parent furniture

================================================================================
MSG: interactive_world_msgs/Placement
interactive_world_msgs/Item item          # item placed in the placement
interactive_world_msgs/Room room          # the room the item is placed in
interactive_world_msgs/Surface surface    # the surface the item is placed on
string reference_frame_id                 # name of the target reference frame for the placement
geometry_msgs/Point position              # position of the placement
float64 rotation                          # rotation of the placement (along the z-axis)
"""
  __slots__ = ['data']
  _slot_types = ['interactive_world_msgs/PlacementSet[]']

  def __init__(self, *args, **kwds):
    """
    Constructor. Any message fields that are implicitly/explicitly
    set to None will be assigned a default value. The recommend
    use is keyword arguments as this is more robust to future message
    changes.  You cannot mix in-order arguments and keyword arguments.

    The available fields are:
       data

    :param args: complete set of field values, in .msg order
    :param kwds: use keyword arguments corresponding to message field names
    to set specific fields.
    """
    if args or kwds:
      super(TaskTrainingData, self).__init__(*args, **kwds)
      #message fields cannot be None, assign default values for those that are
      if self.data is None:
        self.data = []
    else:
      self.data = []

  def _get_types(self):
    """
    internal API method
    """
    return self._slot_types

  def serialize(self, buff):
    """
    serialize message into buffer
    :param buff: buffer, ``StringIO``
    """
    try:
      length = len(self.data)
      buff.write(_struct_I.pack(length))
      for val1 in self.data:
        _v1 = val1.item
        _x = _v1.name
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        if python3:
          buff.write(struct.pack('<I%sB'%length, length, *_x))
        else:
          buff.write(struct.pack('<I%ss'%length, length, _x))
        _x = _v1
        buff.write(_struct_2d.pack(_x.width, _x.height))
        _v2 = val1.room
        _x = _v2.name
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        if python3:
          buff.write(struct.pack('<I%sB'%length, length, *_x))
        else:
          buff.write(struct.pack('<I%ss'%length, length, _x))
        _x = _v2
        buff.write(_struct_2d.pack(_x.width, _x.height))
        _v3 = _v2.pose
        _v4 = _v3.position
        _x = _v4
        buff.write(_struct_3d.pack(_x.x, _x.y, _x.z))
        _v5 = _v3.orientation
        _x = _v5
        buff.write(_struct_4d.pack(_x.x, _x.y, _x.z, _x.w))
        length = len(_v2.surfaces)
        buff.write(_struct_I.pack(length))
        for val3 in _v2.surfaces:
          _x = val3.name
          length = len(_x)
          if python3 or type(_x) == unicode:
            _x = _x.encode('utf-8')
            length = len(_x)
          if python3:
            buff.write(struct.pack('<I%sB'%length, length, *_x))
          else:
            buff.write(struct.pack('<I%ss'%length, length, _x))
          _x = val3
          buff.write(_struct_2d.pack(_x.width, _x.height))
          _v6 = val3.pose
          _v7 = _v6.position
          _x = _v7
          buff.write(_struct_3d.pack(_x.x, _x.y, _x.z))
          _v8 = _v6.orientation
          _x = _v8
          buff.write(_struct_4d.pack(_x.x, _x.y, _x.z, _x.w))
          length = len(val3.pois)
          buff.write(_struct_I.pack(length))
          for val4 in val3.pois:
            _x = val4.name
            length = len(_x)
            if python3 or type(_x) == unicode:
              _x = _x.encode('utf-8')
              length = len(_x)
            if python3:
              buff.write(struct.pack('<I%sB'%length, length, *_x))
            else:
              buff.write(struct.pack('<I%ss'%length, length, _x))
            _x = val4
            buff.write(_struct_2d.pack(_x.width, _x.height))
            _v9 = val4.pose
            _v10 = _v9.position
            _x = _v10
            buff.write(_struct_3d.pack(_x.x, _x.y, _x.z))
            _v11 = _v9.orientation
            _x = _v11
            buff.write(_struct_4d.pack(_x.x, _x.y, _x.z, _x.w))
        _v12 = val1.surface
        _x = _v12.name
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        if python3:
          buff.write(struct.pack('<I%sB'%length, length, *_x))
        else:
          buff.write(struct.pack('<I%ss'%length, length, _x))
        _x = _v12
        buff.write(_struct_2d.pack(_x.width, _x.height))
        _v13 = _v12.pose
        _v14 = _v13.position
        _x = _v14
        buff.write(_struct_3d.pack(_x.x, _x.y, _x.z))
        _v15 = _v13.orientation
        _x = _v15
        buff.write(_struct_4d.pack(_x.x, _x.y, _x.z, _x.w))
        length = len(_v12.pois)
        buff.write(_struct_I.pack(length))
        for val3 in _v12.pois:
          _x = val3.name
          length = len(_x)
          if python3 or type(_x) == unicode:
            _x = _x.encode('utf-8')
            length = len(_x)
          if python3:
            buff.write(struct.pack('<I%sB'%length, length, *_x))
          else:
            buff.write(struct.pack('<I%ss'%length, length, _x))
          _x = val3
          buff.write(_struct_2d.pack(_x.width, _x.height))
          _v16 = val3.pose
          _v17 = _v16.position
          _x = _v17
          buff.write(_struct_3d.pack(_x.x, _x.y, _x.z))
          _v18 = _v16.orientation
          _x = _v18
          buff.write(_struct_4d.pack(_x.x, _x.y, _x.z, _x.w))
        _x = val1.reference_frame_id
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        if python3:
          buff.write(struct.pack('<I%sB'%length, length, *_x))
        else:
          buff.write(struct.pack('<I%ss'%length, length, _x))
        length = len(val1.placements)
        buff.write(_struct_I.pack(length))
        for val2 in val1.placements:
          _v19 = val2.item
          _x = _v19.name
          length = len(_x)
          if python3 or type(_x) == unicode:
            _x = _x.encode('utf-8')
            length = len(_x)
          if python3:
            buff.write(struct.pack('<I%sB'%length, length, *_x))
          else:
            buff.write(struct.pack('<I%ss'%length, length, _x))
          _x = _v19
          buff.write(_struct_2d.pack(_x.width, _x.height))
          _v20 = val2.room
          _x = _v20.name
          length = len(_x)
          if python3 or type(_x) == unicode:
            _x = _x.encode('utf-8')
            length = len(_x)
          if python3:
            buff.write(struct.pack('<I%sB'%length, length, *_x))
          else:
            buff.write(struct.pack('<I%ss'%length, length, _x))
          _x = _v20
          buff.write(_struct_2d.pack(_x.width, _x.height))
          _v21 = _v20.pose
          _v22 = _v21.position
          _x = _v22
          buff.write(_struct_3d.pack(_x.x, _x.y, _x.z))
          _v23 = _v21.orientation
          _x = _v23
          buff.write(_struct_4d.pack(_x.x, _x.y, _x.z, _x.w))
          length = len(_v20.surfaces)
          buff.write(_struct_I.pack(length))
          for val4 in _v20.surfaces:
            _x = val4.name
            length = len(_x)
            if python3 or type(_x) == unicode:
              _x = _x.encode('utf-8')
              length = len(_x)
            if python3:
              buff.write(struct.pack('<I%sB'%length, length, *_x))
            else:
              buff.write(struct.pack('<I%ss'%length, length, _x))
            _x = val4
            buff.write(_struct_2d.pack(_x.width, _x.height))
            _v24 = val4.pose
            _v25 = _v24.position
            _x = _v25
            buff.write(_struct_3d.pack(_x.x, _x.y, _x.z))
            _v26 = _v24.orientation
            _x = _v26
            buff.write(_struct_4d.pack(_x.x, _x.y, _x.z, _x.w))
            length = len(val4.pois)
            buff.write(_struct_I.pack(length))
            for val5 in val4.pois:
              _x = val5.name
              length = len(_x)
              if python3 or type(_x) == unicode:
                _x = _x.encode('utf-8')
                length = len(_x)
              if python3:
                buff.write(struct.pack('<I%sB'%length, length, *_x))
              else:
                buff.write(struct.pack('<I%ss'%length, length, _x))
              _x = val5
              buff.write(_struct_2d.pack(_x.width, _x.height))
              _v27 = val5.pose
              _v28 = _v27.position
              _x = _v28
              buff.write(_struct_3d.pack(_x.x, _x.y, _x.z))
              _v29 = _v27.orientation
              _x = _v29
              buff.write(_struct_4d.pack(_x.x, _x.y, _x.z, _x.w))
          _v30 = val2.surface
          _x = _v30.name
          length = len(_x)
          if python3 or type(_x) == unicode:
            _x = _x.encode('utf-8')
            length = len(_x)
          if python3:
            buff.write(struct.pack('<I%sB'%length, length, *_x))
          else:
            buff.write(struct.pack('<I%ss'%length, length, _x))
          _x = _v30
          buff.write(_struct_2d.pack(_x.width, _x.height))
          _v31 = _v30.pose
          _v32 = _v31.position
          _x = _v32
          buff.write(_struct_3d.pack(_x.x, _x.y, _x.z))
          _v33 = _v31.orientation
          _x = _v33
          buff.write(_struct_4d.pack(_x.x, _x.y, _x.z, _x.w))
          length = len(_v30.pois)
          buff.write(_struct_I.pack(length))
          for val4 in _v30.pois:
            _x = val4.name
            length = len(_x)
            if python3 or type(_x) == unicode:
              _x = _x.encode('utf-8')
              length = len(_x)
            if python3:
              buff.write(struct.pack('<I%sB'%length, length, *_x))
            else:
              buff.write(struct.pack('<I%ss'%length, length, _x))
            _x = val4
            buff.write(_struct_2d.pack(_x.width, _x.height))
            _v34 = val4.pose
            _v35 = _v34.position
            _x = _v35
            buff.write(_struct_3d.pack(_x.x, _x.y, _x.z))
            _v36 = _v34.orientation
            _x = _v36
            buff.write(_struct_4d.pack(_x.x, _x.y, _x.z, _x.w))
          _x = val2.reference_frame_id
          length = len(_x)
          if python3 or type(_x) == unicode:
            _x = _x.encode('utf-8')
            length = len(_x)
          if python3:
            buff.write(struct.pack('<I%sB'%length, length, *_x))
          else:
            buff.write(struct.pack('<I%ss'%length, length, _x))
          _v37 = val2.position
          _x = _v37
          buff.write(_struct_3d.pack(_x.x, _x.y, _x.z))
          buff.write(_struct_d.pack(val2.rotation))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize(self, str):
    """
    unpack serialized message in str into this message instance
    :param str: byte array of serialized message, ``str``
    """
    try:
      if self.data is None:
        self.data = None
      end = 0
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.data = []
      for i in range(0, length):
        val1 = interactive_world_msgs.msg.PlacementSet()
        _v38 = val1.item
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          _v38.name = str[start:end].decode('utf-8')
        else:
          _v38.name = str[start:end]
        _x = _v38
        start = end
        end += 16
        (_x.width, _x.height,) = _struct_2d.unpack(str[start:end])
        _v39 = val1.room
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          _v39.name = str[start:end].decode('utf-8')
        else:
          _v39.name = str[start:end]
        _x = _v39
        start = end
        end += 16
        (_x.width, _x.height,) = _struct_2d.unpack(str[start:end])
        _v40 = _v39.pose
        _v41 = _v40.position
        _x = _v41
        start = end
        end += 24
        (_x.x, _x.y, _x.z,) = _struct_3d.unpack(str[start:end])
        _v42 = _v40.orientation
        _x = _v42
        start = end
        end += 32
        (_x.x, _x.y, _x.z, _x.w,) = _struct_4d.unpack(str[start:end])
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        _v39.surfaces = []
        for i in range(0, length):
          val3 = interactive_world_msgs.msg.Surface()
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          start = end
          end += length
          if python3:
            val3.name = str[start:end].decode('utf-8')
          else:
            val3.name = str[start:end]
          _x = val3
          start = end
          end += 16
          (_x.width, _x.height,) = _struct_2d.unpack(str[start:end])
          _v43 = val3.pose
          _v44 = _v43.position
          _x = _v44
          start = end
          end += 24
          (_x.x, _x.y, _x.z,) = _struct_3d.unpack(str[start:end])
          _v45 = _v43.orientation
          _x = _v45
          start = end
          end += 32
          (_x.x, _x.y, _x.z, _x.w,) = _struct_4d.unpack(str[start:end])
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          val3.pois = []
          for i in range(0, length):
            val4 = interactive_world_msgs.msg.PointOfInterest()
            start = end
            end += 4
            (length,) = _struct_I.unpack(str[start:end])
            start = end
            end += length
            if python3:
              val4.name = str[start:end].decode('utf-8')
            else:
              val4.name = str[start:end]
            _x = val4
            start = end
            end += 16
            (_x.width, _x.height,) = _struct_2d.unpack(str[start:end])
            _v46 = val4.pose
            _v47 = _v46.position
            _x = _v47
            start = end
            end += 24
            (_x.x, _x.y, _x.z,) = _struct_3d.unpack(str[start:end])
            _v48 = _v46.orientation
            _x = _v48
            start = end
            end += 32
            (_x.x, _x.y, _x.z, _x.w,) = _struct_4d.unpack(str[start:end])
            val3.pois.append(val4)
          _v39.surfaces.append(val3)
        _v49 = val1.surface
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          _v49.name = str[start:end].decode('utf-8')
        else:
          _v49.name = str[start:end]
        _x = _v49
        start = end
        end += 16
        (_x.width, _x.height,) = _struct_2d.unpack(str[start:end])
        _v50 = _v49.pose
        _v51 = _v50.position
        _x = _v51
        start = end
        end += 24
        (_x.x, _x.y, _x.z,) = _struct_3d.unpack(str[start:end])
        _v52 = _v50.orientation
        _x = _v52
        start = end
        end += 32
        (_x.x, _x.y, _x.z, _x.w,) = _struct_4d.unpack(str[start:end])
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        _v49.pois = []
        for i in range(0, length):
          val3 = interactive_world_msgs.msg.PointOfInterest()
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          start = end
          end += length
          if python3:
            val3.name = str[start:end].decode('utf-8')
          else:
            val3.name = str[start:end]
          _x = val3
          start = end
          end += 16
          (_x.width, _x.height,) = _struct_2d.unpack(str[start:end])
          _v53 = val3.pose
          _v54 = _v53.position
          _x = _v54
          start = end
          end += 24
          (_x.x, _x.y, _x.z,) = _struct_3d.unpack(str[start:end])
          _v55 = _v53.orientation
          _x = _v55
          start = end
          end += 32
          (_x.x, _x.y, _x.z, _x.w,) = _struct_4d.unpack(str[start:end])
          _v49.pois.append(val3)
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          val1.reference_frame_id = str[start:end].decode('utf-8')
        else:
          val1.reference_frame_id = str[start:end]
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        val1.placements = []
        for i in range(0, length):
          val2 = interactive_world_msgs.msg.Placement()
          _v56 = val2.item
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          start = end
          end += length
          if python3:
            _v56.name = str[start:end].decode('utf-8')
          else:
            _v56.name = str[start:end]
          _x = _v56
          start = end
          end += 16
          (_x.width, _x.height,) = _struct_2d.unpack(str[start:end])
          _v57 = val2.room
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          start = end
          end += length
          if python3:
            _v57.name = str[start:end].decode('utf-8')
          else:
            _v57.name = str[start:end]
          _x = _v57
          start = end
          end += 16
          (_x.width, _x.height,) = _struct_2d.unpack(str[start:end])
          _v58 = _v57.pose
          _v59 = _v58.position
          _x = _v59
          start = end
          end += 24
          (_x.x, _x.y, _x.z,) = _struct_3d.unpack(str[start:end])
          _v60 = _v58.orientation
          _x = _v60
          start = end
          end += 32
          (_x.x, _x.y, _x.z, _x.w,) = _struct_4d.unpack(str[start:end])
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          _v57.surfaces = []
          for i in range(0, length):
            val4 = interactive_world_msgs.msg.Surface()
            start = end
            end += 4
            (length,) = _struct_I.unpack(str[start:end])
            start = end
            end += length
            if python3:
              val4.name = str[start:end].decode('utf-8')
            else:
              val4.name = str[start:end]
            _x = val4
            start = end
            end += 16
            (_x.width, _x.height,) = _struct_2d.unpack(str[start:end])
            _v61 = val4.pose
            _v62 = _v61.position
            _x = _v62
            start = end
            end += 24
            (_x.x, _x.y, _x.z,) = _struct_3d.unpack(str[start:end])
            _v63 = _v61.orientation
            _x = _v63
            start = end
            end += 32
            (_x.x, _x.y, _x.z, _x.w,) = _struct_4d.unpack(str[start:end])
            start = end
            end += 4
            (length,) = _struct_I.unpack(str[start:end])
            val4.pois = []
            for i in range(0, length):
              val5 = interactive_world_msgs.msg.PointOfInterest()
              start = end
              end += 4
              (length,) = _struct_I.unpack(str[start:end])
              start = end
              end += length
              if python3:
                val5.name = str[start:end].decode('utf-8')
              else:
                val5.name = str[start:end]
              _x = val5
              start = end
              end += 16
              (_x.width, _x.height,) = _struct_2d.unpack(str[start:end])
              _v64 = val5.pose
              _v65 = _v64.position
              _x = _v65
              start = end
              end += 24
              (_x.x, _x.y, _x.z,) = _struct_3d.unpack(str[start:end])
              _v66 = _v64.orientation
              _x = _v66
              start = end
              end += 32
              (_x.x, _x.y, _x.z, _x.w,) = _struct_4d.unpack(str[start:end])
              val4.pois.append(val5)
            _v57.surfaces.append(val4)
          _v67 = val2.surface
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          start = end
          end += length
          if python3:
            _v67.name = str[start:end].decode('utf-8')
          else:
            _v67.name = str[start:end]
          _x = _v67
          start = end
          end += 16
          (_x.width, _x.height,) = _struct_2d.unpack(str[start:end])
          _v68 = _v67.pose
          _v69 = _v68.position
          _x = _v69
          start = end
          end += 24
          (_x.x, _x.y, _x.z,) = _struct_3d.unpack(str[start:end])
          _v70 = _v68.orientation
          _x = _v70
          start = end
          end += 32
          (_x.x, _x.y, _x.z, _x.w,) = _struct_4d.unpack(str[start:end])
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          _v67.pois = []
          for i in range(0, length):
            val4 = interactive_world_msgs.msg.PointOfInterest()
            start = end
            end += 4
            (length,) = _struct_I.unpack(str[start:end])
            start = end
            end += length
            if python3:
              val4.name = str[start:end].decode('utf-8')
            else:
              val4.name = str[start:end]
            _x = val4
            start = end
            end += 16
            (_x.width, _x.height,) = _struct_2d.unpack(str[start:end])
            _v71 = val4.pose
            _v72 = _v71.position
            _x = _v72
            start = end
            end += 24
            (_x.x, _x.y, _x.z,) = _struct_3d.unpack(str[start:end])
            _v73 = _v71.orientation
            _x = _v73
            start = end
            end += 32
            (_x.x, _x.y, _x.z, _x.w,) = _struct_4d.unpack(str[start:end])
            _v67.pois.append(val4)
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          start = end
          end += length
          if python3:
            val2.reference_frame_id = str[start:end].decode('utf-8')
          else:
            val2.reference_frame_id = str[start:end]
          _v74 = val2.position
          _x = _v74
          start = end
          end += 24
          (_x.x, _x.y, _x.z,) = _struct_3d.unpack(str[start:end])
          start = end
          end += 8
          (val2.rotation,) = _struct_d.unpack(str[start:end])
          val1.placements.append(val2)
        self.data.append(val1)
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e) #most likely buffer underfill


  def serialize_numpy(self, buff, numpy):
    """
    serialize message with numpy array types into buffer
    :param buff: buffer, ``StringIO``
    :param numpy: numpy python module
    """
    try:
      length = len(self.data)
      buff.write(_struct_I.pack(length))
      for val1 in self.data:
        _v75 = val1.item
        _x = _v75.name
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        if python3:
          buff.write(struct.pack('<I%sB'%length, length, *_x))
        else:
          buff.write(struct.pack('<I%ss'%length, length, _x))
        _x = _v75
        buff.write(_struct_2d.pack(_x.width, _x.height))
        _v76 = val1.room
        _x = _v76.name
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        if python3:
          buff.write(struct.pack('<I%sB'%length, length, *_x))
        else:
          buff.write(struct.pack('<I%ss'%length, length, _x))
        _x = _v76
        buff.write(_struct_2d.pack(_x.width, _x.height))
        _v77 = _v76.pose
        _v78 = _v77.position
        _x = _v78
        buff.write(_struct_3d.pack(_x.x, _x.y, _x.z))
        _v79 = _v77.orientation
        _x = _v79
        buff.write(_struct_4d.pack(_x.x, _x.y, _x.z, _x.w))
        length = len(_v76.surfaces)
        buff.write(_struct_I.pack(length))
        for val3 in _v76.surfaces:
          _x = val3.name
          length = len(_x)
          if python3 or type(_x) == unicode:
            _x = _x.encode('utf-8')
            length = len(_x)
          if python3:
            buff.write(struct.pack('<I%sB'%length, length, *_x))
          else:
            buff.write(struct.pack('<I%ss'%length, length, _x))
          _x = val3
          buff.write(_struct_2d.pack(_x.width, _x.height))
          _v80 = val3.pose
          _v81 = _v80.position
          _x = _v81
          buff.write(_struct_3d.pack(_x.x, _x.y, _x.z))
          _v82 = _v80.orientation
          _x = _v82
          buff.write(_struct_4d.pack(_x.x, _x.y, _x.z, _x.w))
          length = len(val3.pois)
          buff.write(_struct_I.pack(length))
          for val4 in val3.pois:
            _x = val4.name
            length = len(_x)
            if python3 or type(_x) == unicode:
              _x = _x.encode('utf-8')
              length = len(_x)
            if python3:
              buff.write(struct.pack('<I%sB'%length, length, *_x))
            else:
              buff.write(struct.pack('<I%ss'%length, length, _x))
            _x = val4
            buff.write(_struct_2d.pack(_x.width, _x.height))
            _v83 = val4.pose
            _v84 = _v83.position
            _x = _v84
            buff.write(_struct_3d.pack(_x.x, _x.y, _x.z))
            _v85 = _v83.orientation
            _x = _v85
            buff.write(_struct_4d.pack(_x.x, _x.y, _x.z, _x.w))
        _v86 = val1.surface
        _x = _v86.name
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        if python3:
          buff.write(struct.pack('<I%sB'%length, length, *_x))
        else:
          buff.write(struct.pack('<I%ss'%length, length, _x))
        _x = _v86
        buff.write(_struct_2d.pack(_x.width, _x.height))
        _v87 = _v86.pose
        _v88 = _v87.position
        _x = _v88
        buff.write(_struct_3d.pack(_x.x, _x.y, _x.z))
        _v89 = _v87.orientation
        _x = _v89
        buff.write(_struct_4d.pack(_x.x, _x.y, _x.z, _x.w))
        length = len(_v86.pois)
        buff.write(_struct_I.pack(length))
        for val3 in _v86.pois:
          _x = val3.name
          length = len(_x)
          if python3 or type(_x) == unicode:
            _x = _x.encode('utf-8')
            length = len(_x)
          if python3:
            buff.write(struct.pack('<I%sB'%length, length, *_x))
          else:
            buff.write(struct.pack('<I%ss'%length, length, _x))
          _x = val3
          buff.write(_struct_2d.pack(_x.width, _x.height))
          _v90 = val3.pose
          _v91 = _v90.position
          _x = _v91
          buff.write(_struct_3d.pack(_x.x, _x.y, _x.z))
          _v92 = _v90.orientation
          _x = _v92
          buff.write(_struct_4d.pack(_x.x, _x.y, _x.z, _x.w))
        _x = val1.reference_frame_id
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        if python3:
          buff.write(struct.pack('<I%sB'%length, length, *_x))
        else:
          buff.write(struct.pack('<I%ss'%length, length, _x))
        length = len(val1.placements)
        buff.write(_struct_I.pack(length))
        for val2 in val1.placements:
          _v93 = val2.item
          _x = _v93.name
          length = len(_x)
          if python3 or type(_x) == unicode:
            _x = _x.encode('utf-8')
            length = len(_x)
          if python3:
            buff.write(struct.pack('<I%sB'%length, length, *_x))
          else:
            buff.write(struct.pack('<I%ss'%length, length, _x))
          _x = _v93
          buff.write(_struct_2d.pack(_x.width, _x.height))
          _v94 = val2.room
          _x = _v94.name
          length = len(_x)
          if python3 or type(_x) == unicode:
            _x = _x.encode('utf-8')
            length = len(_x)
          if python3:
            buff.write(struct.pack('<I%sB'%length, length, *_x))
          else:
            buff.write(struct.pack('<I%ss'%length, length, _x))
          _x = _v94
          buff.write(_struct_2d.pack(_x.width, _x.height))
          _v95 = _v94.pose
          _v96 = _v95.position
          _x = _v96
          buff.write(_struct_3d.pack(_x.x, _x.y, _x.z))
          _v97 = _v95.orientation
          _x = _v97
          buff.write(_struct_4d.pack(_x.x, _x.y, _x.z, _x.w))
          length = len(_v94.surfaces)
          buff.write(_struct_I.pack(length))
          for val4 in _v94.surfaces:
            _x = val4.name
            length = len(_x)
            if python3 or type(_x) == unicode:
              _x = _x.encode('utf-8')
              length = len(_x)
            if python3:
              buff.write(struct.pack('<I%sB'%length, length, *_x))
            else:
              buff.write(struct.pack('<I%ss'%length, length, _x))
            _x = val4
            buff.write(_struct_2d.pack(_x.width, _x.height))
            _v98 = val4.pose
            _v99 = _v98.position
            _x = _v99
            buff.write(_struct_3d.pack(_x.x, _x.y, _x.z))
            _v100 = _v98.orientation
            _x = _v100
            buff.write(_struct_4d.pack(_x.x, _x.y, _x.z, _x.w))
            length = len(val4.pois)
            buff.write(_struct_I.pack(length))
            for val5 in val4.pois:
              _x = val5.name
              length = len(_x)
              if python3 or type(_x) == unicode:
                _x = _x.encode('utf-8')
                length = len(_x)
              if python3:
                buff.write(struct.pack('<I%sB'%length, length, *_x))
              else:
                buff.write(struct.pack('<I%ss'%length, length, _x))
              _x = val5
              buff.write(_struct_2d.pack(_x.width, _x.height))
              _v101 = val5.pose
              _v102 = _v101.position
              _x = _v102
              buff.write(_struct_3d.pack(_x.x, _x.y, _x.z))
              _v103 = _v101.orientation
              _x = _v103
              buff.write(_struct_4d.pack(_x.x, _x.y, _x.z, _x.w))
          _v104 = val2.surface
          _x = _v104.name
          length = len(_x)
          if python3 or type(_x) == unicode:
            _x = _x.encode('utf-8')
            length = len(_x)
          if python3:
            buff.write(struct.pack('<I%sB'%length, length, *_x))
          else:
            buff.write(struct.pack('<I%ss'%length, length, _x))
          _x = _v104
          buff.write(_struct_2d.pack(_x.width, _x.height))
          _v105 = _v104.pose
          _v106 = _v105.position
          _x = _v106
          buff.write(_struct_3d.pack(_x.x, _x.y, _x.z))
          _v107 = _v105.orientation
          _x = _v107
          buff.write(_struct_4d.pack(_x.x, _x.y, _x.z, _x.w))
          length = len(_v104.pois)
          buff.write(_struct_I.pack(length))
          for val4 in _v104.pois:
            _x = val4.name
            length = len(_x)
            if python3 or type(_x) == unicode:
              _x = _x.encode('utf-8')
              length = len(_x)
            if python3:
              buff.write(struct.pack('<I%sB'%length, length, *_x))
            else:
              buff.write(struct.pack('<I%ss'%length, length, _x))
            _x = val4
            buff.write(_struct_2d.pack(_x.width, _x.height))
            _v108 = val4.pose
            _v109 = _v108.position
            _x = _v109
            buff.write(_struct_3d.pack(_x.x, _x.y, _x.z))
            _v110 = _v108.orientation
            _x = _v110
            buff.write(_struct_4d.pack(_x.x, _x.y, _x.z, _x.w))
          _x = val2.reference_frame_id
          length = len(_x)
          if python3 or type(_x) == unicode:
            _x = _x.encode('utf-8')
            length = len(_x)
          if python3:
            buff.write(struct.pack('<I%sB'%length, length, *_x))
          else:
            buff.write(struct.pack('<I%ss'%length, length, _x))
          _v111 = val2.position
          _x = _v111
          buff.write(_struct_3d.pack(_x.x, _x.y, _x.z))
          buff.write(_struct_d.pack(val2.rotation))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize_numpy(self, str, numpy):
    """
    unpack serialized message in str into this message instance using numpy for array types
    :param str: byte array of serialized message, ``str``
    :param numpy: numpy python module
    """
    try:
      if self.data is None:
        self.data = None
      end = 0
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.data = []
      for i in range(0, length):
        val1 = interactive_world_msgs.msg.PlacementSet()
        _v112 = val1.item
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          _v112.name = str[start:end].decode('utf-8')
        else:
          _v112.name = str[start:end]
        _x = _v112
        start = end
        end += 16
        (_x.width, _x.height,) = _struct_2d.unpack(str[start:end])
        _v113 = val1.room
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          _v113.name = str[start:end].decode('utf-8')
        else:
          _v113.name = str[start:end]
        _x = _v113
        start = end
        end += 16
        (_x.width, _x.height,) = _struct_2d.unpack(str[start:end])
        _v114 = _v113.pose
        _v115 = _v114.position
        _x = _v115
        start = end
        end += 24
        (_x.x, _x.y, _x.z,) = _struct_3d.unpack(str[start:end])
        _v116 = _v114.orientation
        _x = _v116
        start = end
        end += 32
        (_x.x, _x.y, _x.z, _x.w,) = _struct_4d.unpack(str[start:end])
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        _v113.surfaces = []
        for i in range(0, length):
          val3 = interactive_world_msgs.msg.Surface()
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          start = end
          end += length
          if python3:
            val3.name = str[start:end].decode('utf-8')
          else:
            val3.name = str[start:end]
          _x = val3
          start = end
          end += 16
          (_x.width, _x.height,) = _struct_2d.unpack(str[start:end])
          _v117 = val3.pose
          _v118 = _v117.position
          _x = _v118
          start = end
          end += 24
          (_x.x, _x.y, _x.z,) = _struct_3d.unpack(str[start:end])
          _v119 = _v117.orientation
          _x = _v119
          start = end
          end += 32
          (_x.x, _x.y, _x.z, _x.w,) = _struct_4d.unpack(str[start:end])
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          val3.pois = []
          for i in range(0, length):
            val4 = interactive_world_msgs.msg.PointOfInterest()
            start = end
            end += 4
            (length,) = _struct_I.unpack(str[start:end])
            start = end
            end += length
            if python3:
              val4.name = str[start:end].decode('utf-8')
            else:
              val4.name = str[start:end]
            _x = val4
            start = end
            end += 16
            (_x.width, _x.height,) = _struct_2d.unpack(str[start:end])
            _v120 = val4.pose
            _v121 = _v120.position
            _x = _v121
            start = end
            end += 24
            (_x.x, _x.y, _x.z,) = _struct_3d.unpack(str[start:end])
            _v122 = _v120.orientation
            _x = _v122
            start = end
            end += 32
            (_x.x, _x.y, _x.z, _x.w,) = _struct_4d.unpack(str[start:end])
            val3.pois.append(val4)
          _v113.surfaces.append(val3)
        _v123 = val1.surface
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          _v123.name = str[start:end].decode('utf-8')
        else:
          _v123.name = str[start:end]
        _x = _v123
        start = end
        end += 16
        (_x.width, _x.height,) = _struct_2d.unpack(str[start:end])
        _v124 = _v123.pose
        _v125 = _v124.position
        _x = _v125
        start = end
        end += 24
        (_x.x, _x.y, _x.z,) = _struct_3d.unpack(str[start:end])
        _v126 = _v124.orientation
        _x = _v126
        start = end
        end += 32
        (_x.x, _x.y, _x.z, _x.w,) = _struct_4d.unpack(str[start:end])
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        _v123.pois = []
        for i in range(0, length):
          val3 = interactive_world_msgs.msg.PointOfInterest()
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          start = end
          end += length
          if python3:
            val3.name = str[start:end].decode('utf-8')
          else:
            val3.name = str[start:end]
          _x = val3
          start = end
          end += 16
          (_x.width, _x.height,) = _struct_2d.unpack(str[start:end])
          _v127 = val3.pose
          _v128 = _v127.position
          _x = _v128
          start = end
          end += 24
          (_x.x, _x.y, _x.z,) = _struct_3d.unpack(str[start:end])
          _v129 = _v127.orientation
          _x = _v129
          start = end
          end += 32
          (_x.x, _x.y, _x.z, _x.w,) = _struct_4d.unpack(str[start:end])
          _v123.pois.append(val3)
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          val1.reference_frame_id = str[start:end].decode('utf-8')
        else:
          val1.reference_frame_id = str[start:end]
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        val1.placements = []
        for i in range(0, length):
          val2 = interactive_world_msgs.msg.Placement()
          _v130 = val2.item
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          start = end
          end += length
          if python3:
            _v130.name = str[start:end].decode('utf-8')
          else:
            _v130.name = str[start:end]
          _x = _v130
          start = end
          end += 16
          (_x.width, _x.height,) = _struct_2d.unpack(str[start:end])
          _v131 = val2.room
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          start = end
          end += length
          if python3:
            _v131.name = str[start:end].decode('utf-8')
          else:
            _v131.name = str[start:end]
          _x = _v131
          start = end
          end += 16
          (_x.width, _x.height,) = _struct_2d.unpack(str[start:end])
          _v132 = _v131.pose
          _v133 = _v132.position
          _x = _v133
          start = end
          end += 24
          (_x.x, _x.y, _x.z,) = _struct_3d.unpack(str[start:end])
          _v134 = _v132.orientation
          _x = _v134
          start = end
          end += 32
          (_x.x, _x.y, _x.z, _x.w,) = _struct_4d.unpack(str[start:end])
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          _v131.surfaces = []
          for i in range(0, length):
            val4 = interactive_world_msgs.msg.Surface()
            start = end
            end += 4
            (length,) = _struct_I.unpack(str[start:end])
            start = end
            end += length
            if python3:
              val4.name = str[start:end].decode('utf-8')
            else:
              val4.name = str[start:end]
            _x = val4
            start = end
            end += 16
            (_x.width, _x.height,) = _struct_2d.unpack(str[start:end])
            _v135 = val4.pose
            _v136 = _v135.position
            _x = _v136
            start = end
            end += 24
            (_x.x, _x.y, _x.z,) = _struct_3d.unpack(str[start:end])
            _v137 = _v135.orientation
            _x = _v137
            start = end
            end += 32
            (_x.x, _x.y, _x.z, _x.w,) = _struct_4d.unpack(str[start:end])
            start = end
            end += 4
            (length,) = _struct_I.unpack(str[start:end])
            val4.pois = []
            for i in range(0, length):
              val5 = interactive_world_msgs.msg.PointOfInterest()
              start = end
              end += 4
              (length,) = _struct_I.unpack(str[start:end])
              start = end
              end += length
              if python3:
                val5.name = str[start:end].decode('utf-8')
              else:
                val5.name = str[start:end]
              _x = val5
              start = end
              end += 16
              (_x.width, _x.height,) = _struct_2d.unpack(str[start:end])
              _v138 = val5.pose
              _v139 = _v138.position
              _x = _v139
              start = end
              end += 24
              (_x.x, _x.y, _x.z,) = _struct_3d.unpack(str[start:end])
              _v140 = _v138.orientation
              _x = _v140
              start = end
              end += 32
              (_x.x, _x.y, _x.z, _x.w,) = _struct_4d.unpack(str[start:end])
              val4.pois.append(val5)
            _v131.surfaces.append(val4)
          _v141 = val2.surface
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          start = end
          end += length
          if python3:
            _v141.name = str[start:end].decode('utf-8')
          else:
            _v141.name = str[start:end]
          _x = _v141
          start = end
          end += 16
          (_x.width, _x.height,) = _struct_2d.unpack(str[start:end])
          _v142 = _v141.pose
          _v143 = _v142.position
          _x = _v143
          start = end
          end += 24
          (_x.x, _x.y, _x.z,) = _struct_3d.unpack(str[start:end])
          _v144 = _v142.orientation
          _x = _v144
          start = end
          end += 32
          (_x.x, _x.y, _x.z, _x.w,) = _struct_4d.unpack(str[start:end])
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          _v141.pois = []
          for i in range(0, length):
            val4 = interactive_world_msgs.msg.PointOfInterest()
            start = end
            end += 4
            (length,) = _struct_I.unpack(str[start:end])
            start = end
            end += length
            if python3:
              val4.name = str[start:end].decode('utf-8')
            else:
              val4.name = str[start:end]
            _x = val4
            start = end
            end += 16
            (_x.width, _x.height,) = _struct_2d.unpack(str[start:end])
            _v145 = val4.pose
            _v146 = _v145.position
            _x = _v146
            start = end
            end += 24
            (_x.x, _x.y, _x.z,) = _struct_3d.unpack(str[start:end])
            _v147 = _v145.orientation
            _x = _v147
            start = end
            end += 32
            (_x.x, _x.y, _x.z, _x.w,) = _struct_4d.unpack(str[start:end])
            _v141.pois.append(val4)
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          start = end
          end += length
          if python3:
            val2.reference_frame_id = str[start:end].decode('utf-8')
          else:
            val2.reference_frame_id = str[start:end]
          _v148 = val2.position
          _x = _v148
          start = end
          end += 24
          (_x.x, _x.y, _x.z,) = _struct_3d.unpack(str[start:end])
          start = end
          end += 8
          (val2.rotation,) = _struct_d.unpack(str[start:end])
          val1.placements.append(val2)
        self.data.append(val1)
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e) #most likely buffer underfill

_struct_I = genpy.struct_I
_struct_2d = struct.Struct("<2d")
_struct_4d = struct.Struct("<4d")
_struct_d = struct.Struct("<d")
_struct_3d = struct.Struct("<3d")
